<?php

namespace DataView;

class Fop_mail_host_box_dir {
  
  

  
  

    // --- Statische Methoden ---
  
  public static function renderScript() { 
    
    
    // --- BLOCK: main ---
    
								\FOP\I18n::ensureIsLoaded();
								?>
								<script type="text/javascript">
									
    function changefilter_fop_mail_host_box_dir_mailboxListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_mailbox', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_mailbox'];
		  }reloadfop_mail_host_box_dir();
        
    }

		var ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout = null;
		function changefilter_fop_mail_host_box_dir_mailboxSearchFilter(val, callback) {
			if(ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout) clearTimeout(ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout);

			ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir({action: 'getfilter_fop_mail_host_box_dir_mailboxItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_mailbox_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_mailboxListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_mailbox_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_mailbox_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="fa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373" type="text">' +
			'<label class="mdl-textfield__label" for="fa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_mailbox', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_mailbox_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_mailbox'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir();
					
				} else {
					$('#table_fop_mail_host_box_dir').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_mailboxSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir::getfilter_fop_mail_host_box_dir_mailboxItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_mailbox_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_mailbox'];
				reload('', items);reloadfop_mail_host_box_dir();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_mailbox', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_mailboxListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									
    function changefilter_fop_mail_host_box_dir_mailboxListMultiFilter(val, cb) {
		  if (val) {
			  querySet('filter_fop_mail_host_box_dir_mailbox', val, cb.checked);
		  } else {
			  delete query['filter_fop_mail_host_box_dir_mailbox'];
		  }reloadfop_mail_host_box_dir();
        
    }

		var ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout = null;
		function changefilter_fop_mail_host_box_dir_mailboxSearchFilter(val, callback) {
			if(ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout) clearTimeout(ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout);

			ifa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373timeout = setTimeout(function() {
				$.getJSON(reloadfop_mail_host_box_dir({action: 'getfilter_fop_mail_host_box_dir_mailboxItemsByString', 'fstr': val}, true), function(r) {
					callback(r);
					query['filter_fop_mail_host_box_dir_mailbox_orig'] = val;
				});
			}, 300);
		}

	function getfilter_fop_mail_host_box_dir_mailboxListMultiFilter() {
		var gui = $("<div class='fop-floatsorter'></div>");
		// TODO: usability #1866 auf ajax warten bevor ENTER behandelt wird
		var fstr = <?php echo(isset($_GET['filter_fop_mail_host_box_dir_mailbox_orig']) ? json_encode($_GET['filter_fop_mail_host_box_dir_mailbox_orig']) : '""') ?>;
		var search = $('<div class="mdl-textfield mdl-js-textfield">' + 
			'<input value="" class="mdl-textfield__input" id="fa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373" type="text">' +
			'<label class="mdl-textfield__label" for="fa4a860a2f929f43f76862ebab63cd214a855b3184649358ccaf7a630ba4c373">Filter...</label>' +
			'</div>');
		search.find('input').val(fstr).keyup(function (event) {
			var self = this;
			if ((event.keyCode || e.which) == 13) {
				var hasChecked = false;
				if (this.value) {
					// search value + tick all search results
					checkboxes.find('input').each(function (i, inp) {
						if (!inp.checked && $(inp).data('value')) {
							inp.checked = true;
							querySet('filter_fop_mail_host_box_dir_mailbox', $(inp).data('value'), true);
							hasChecked = true;
						}
					});
				} else {
					// untick all
					search.find('input').val('');
					query['filter_fop_mail_host_box_dir_mailbox_orig'] = '';
					delete query['filter_fop_mail_host_box_dir_mailbox'];
					reload('', items);
					hasChecked = true;
				}
				if (hasChecked) {reloadfop_mail_host_box_dir();
					
				} else {
					$('#table_fop_mail_host_box_dir').find('.fop-table-row:first').click();
				}
			} else {
				changefilter_fop_mail_host_box_dir_mailboxSearchFilter(this.value, function (result) {
					reload(self.value, result);
				});
			}
		});
		gui.append(search);

		var checkboxes = $("<div></div>").css({maxHeight: '200px', overflow: 'auto'});
		var items = <?php
			// TODO: deps-Variable füllen mit DV-Parametern vom DataView id
			echo json_encode(\DataView\Fop_mail_host_box_dir::getfilter_fop_mail_host_box_dir_mailboxItemsByStringAction(''));
		?>;

		function reload(fstr, items) {
			// rerender checkbox list
			checkboxes.empty();
			checkboxes.append($('<i style="cursor: pointer;"><?php echo _('show all'); ?></i>').click(function () {
				search.find('input').val('');
				query['filter_fop_mail_host_box_dir_mailbox_orig'] = '';
				delete query['filter_fop_mail_host_box_dir_mailbox'];
				reload('', items);reloadfop_mail_host_box_dir();
				
			})).append('<br/>');
			// NULL-Wert auch suchbar #2057 (kommt als ID=0 an, muss für die idlist in _null geändert werden)
			for (var i = 0; i < items.length; i++) {
				let value = (items[i].ID === '0' ? '_null' : items[i].ID);
				let descr = items[i].description;
				let checked = querySet('filter_fop_mail_host_box_dir_mailbox', value);
				if (!fstr || checked || descr.toLowerCase().includes(fstr.toLowerCase())) {
					checkboxes.append($('<input type=\'checkbox\'  onclick=\'changefilter_fop_mail_host_box_dir_mailboxListMultiFilter("' + value + '", this)\' ' + (checked ? ' checked>': '> ')).data('value', value)).append($('<span></span>').text(descr).prepend('&nbsp;')).append('<br/>');
				}
			 }
		}
		reload(fstr, items);
		gui.append(checkboxes);

		return gui;
	}
									function updateNumberfop_mail_host_box_dir(col) {
										//var checklist = window.DataViewChecked['fop_mail_host_box_dir'][col];
										//if (checklist.id) {
											// checklist is online
											// TODO: check if cache is alive, otherwise reload from ajax, delay execution and return now
											//checklist.ranges = [[1,10000000]]; // mostly we use indirect idlists to tick all marks; so this is an approximation
										//}
										// checkboxes aktualisieren
										if (window.DataViewChecked && window.DataViewChecked['fop_mail_host_box_dir'] && window.DataViewChecked['fop_mail_host_box_dir'][col].ranges.length > 0) {
											$('.fop_mail_host_box_dir__mass-action').css('visibility', 'visible');
											$('.fop_mail_host_box_dir__action').css('visibility', 'hidden');
										} else {
											$('.fop_mail_host_box_dir__mass-action').css('visibility', 'hidden');
											$('.fop_mail_host_box_dir__action').css('visibility', 'visible');
										}
										$('.fop_mail_host_box_dir__checkbox').each(function (idx, x) {
											for (var cssclass of x.classList) {
												if (cssclass.startsWith('fop_mail_host_box_dir__checkbox-'+col+'-')) {
													var my_id = cssclass.substr(('fop_mail_host_box_dir__checkbox-'+col+'-').length);
													if (window.DataViewChecked) {
														x.MaterialCheckbox[checklist.has(my_id) ? 'check' : 'uncheck']();
													}
												}
											}
										});
									}
									function reloadfop_mail_host_box_dir (params, returnUrl, onlyScroll, addPadding = 0) {
										// copy query
										let nq = JSON.parse(JSON.stringify(query));
										nq['parent_request'] = <?php echo json_encode(strtok(\FOP\Util::getBackUrl(), '?')); ?>;
										<?php if (isset($_GET['select'])) { ?>nq['select'] = 'select';<?php } ?>
										
										if (params) {
											for (var i in params) nq[i] = params[i];
											var action = nq['action'];
											delete nq['action'];
											let querystr = "DataView/Fop_mail_host_box_dir/" + action + "?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// direkt aufrufen (ist wohl ein Download oder so)
											if (returnUrl) return querystr;
											window.location.href = querystr;
										} else {
											let querystr;
											
											
											<?php if ((!\FOP\User::getIsGuest()) && (!\FOP\User::getIsGuest())) { ?>
											delete nq['action'];
											querystr = "DataView/Fop_mail_host_box_dir/renderTabTable?" + Object.keys(nq).map(function(k){ return k + "=" +  encodeURIComponent(nq[k]); }).join("&");
											// per Ajax laden
											if(!$("#fop_mail_host_box_dir-table")?.parent()?.parent()?.hasClass('fop-form-feature-collapsed') || $("#fop_mail_host_box_dir-table")?.parent()?.parent()?.hasClass('fop-form-feature-mode-area')) {
											$.get(querystr, function(data){
												var tab = $("#fop_mail_host_box_dir-table");
												var top = tab.find('.fop-table-body-inner');
												var el;
												if (onlyScroll && (el = $('<div class="tabcontent">' + data + '</div>').find('.fop-table-body-inner'))) {
													// nur Scroll-Bereich ersetzen
													var paddingTop = parseInt(el.css('paddingTop') || '0px', 10);
													var minHeight = parseInt(el.css('minHeight'), 10)
													paddingTop += addPadding;
													minHeight += addPadding;
													top.css({paddingTop: paddingTop.toString()+'px', minHeight: minHeight.toString()+'px'}); // Offset
													el = el.children();
													top.empty();
													top.append(el);
													el = top; // top-upgrade doppelt machen, dadurch vermeiden wir das Array-upgrade => Performance
												} else {
													// gesamten Tab ersetzen
													tab.children().remove();
													el = tab.html('<div class="tabcontent">' + data + '</div>');
												}
												try {
													for (var i = 0; i < el.length; i++) upgradeDOM(el[i]);
												} catch (e) {
													console.log(e);
												}
												upgradeTable(el.find('.fop-table .fop-table-header')); // Falls es Tabellen-Layout ist: Spalten-Order anpassen
												flushURL(); // Neue URL in Titelleiste eintragen

												// Checkbox-Auswahl ankreuzen
												updateNumberfop_mail_host_box_dir('ID');
											});
											} else {
												// gesamten Tab ersetzen
												var tab = $("#fop_mail_host_box_dir-table");
												tab.children().remove();
												el = tab.html('<div class="fop-lazy-reload" onclick="reloadfop_mail_host_box_dir()"></div>');
											}
											<?php } ?>
											
										}
									}
									function checkfop_mail_host_box_dir (id, col, checked) {
										// ID-Liste aufbauen
										if (!window.DataViewChecked) window.DataViewChecked = {};
										if (!window.DataViewChecked['fop_mail_host_box_dir']) window.DataViewChecked['fop_mail_host_box_dir'] = {};
										if (!window.DataViewChecked['fop_mail_host_box_dir'][col]) window.DataViewChecked['fop_mail_host_box_dir'][col] = new IDList();

										// Abfrage aller gecheckten IDs für eine Tabelle
										if (!id) {
											return window.DataViewChecked['fop_mail_host_box_dir'][col].toString();
										}

										// check all, check id
										if (id == 'all') {
											// TODO: umbauen #1289: 'all' auch nur auf ne idlist reduzieren
											if (checked) {
												$.get(reloadfop_mail_host_box_dir({action: 'getids', col: col}, true), function (ids) {
													window.DataViewChecked['fop_mail_host_box_dir'][col] = new IDList(ids);
													updateNumberfop_mail_host_box_dir(col);
												});
											} else {
												window.DataViewChecked['fop_mail_host_box_dir'][col] = new IDList();
												updateNumberfop_mail_host_box_dir(col);
											}
										} else {
											var ids = new IDList(id);
											var allcb = $('#fop_mail_host_box_dir__all-checkbox');
											if (allcb[0]) {
												allcb[0].parentElement.MaterialCheckbox.uncheck(); // TODO: prüfen, ob Gruppen-CBs voll werden
											}
											if (checked == 'set') {
												window.DataViewChecked['fop_mail_host_box_dir'][col] = ids;
											} else for (id of ids.all()) {
												if (checked) {
													window.DataViewChecked['fop_mail_host_box_dir'][col].push(id);
												} else {
													window.DataViewChecked['fop_mail_host_box_dir'][col].remove(id);
												}
											}
											updateNumberfop_mail_host_box_dir(col);
										}
									}
								</script><?php

    
  }

  public static function renderSpecialFilters() { 
    
    
    // --- BLOCK: main ---
    ?>
	
	<script type"text/javascript">
		function updateSpecialFilter(param, val) {
			query[param] = val.toString();reloadfop_mail_host_box_dir();
			
		}

	</script>
	<?php
	
    
  }

  public static function renderTabTableAction() { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
     ?><div class='fop-dv-buttonbar'><?php if((!\FOP\User::getIsGuest())) { ?><a class="mdl-button mdl-js-button mdl-button--raised mdl-button--colored" onclick="
		var self = this;
		event.preventDefault();
		$.get(reloadfop_mail_host_box_dir({action: 'open', fop_table: 'fop_mail_host_box_dir', fop_id: '_', fop_from: location.href}, true))
		.then(function () {
			window.open_url(self.href, false);
		});" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir::createURL2(['from' => $_GET['from'] ?? null, 'popup' => $_GET['popup'] ?? null])); ?>"><i class="material-icons">add</i> <?php echo(sprintf(_('create %s'), _('emaildirectory_singular'))); ?></a><?php } ?></div><?php 
								\FOP\User::getIsGuest();
								$itemheight = 32;
								$itemsperpage = ceil(1080 / $itemheight * 0.8);
								$page = (isset($_GET['page_fop_mail_host_box_dir']) ? intval($_GET['page_fop_mail_host_box_dir']) : 0);
								$addlines = (isset($_GET['addlines_fop_mail_host_box_dir']) ? intval($_GET['addlines_fop_mail_host_box_dir']) : 0);
								$firstitem = $page * $itemsperpage;
								$sqladdon = ' LIMIT ' . ($itemsperpage * 2) . ' OFFSET ' . ($firstitem);
								$data = self::getData($sqladdon, $_GET);
								$arr = $data["items"];
								$itemcount = $data["itemcount"];
								$lastPage = ceil($itemcount/$itemsperpage-1);
								// calculate width of first column: 67px + 32px for each shortcut
								$firstColumnWidth = 66 + 34 + 34;
								$additionalLines = 0;

									// Spaltenliste zuerst aufbauen, damit sie noch umsortiert werden kann
									$order = 1000;
									$columns = [];
									
										if(true){
											$col = [
												'id' => 'name',
												'desc' => _('Name'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['name'] = $col;
										}
									
										if((false)){
											$col = [
												'id' => 'imap_name',
												'desc' => _('IMAP-Name'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['imap_name'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'nmessages',
												'desc' => _('news'),
												'order' => ++$order,
												'width' => 60, // default value
												'collapsed' => 0

											];
											$columns['nmessages'] = $col;
										}
									
										if(true){
											$col = [
												'id' => 'mailbox',
												'desc' => _('Mailbox'),
												'order' => ++$order,
												'width' => 180, // default value
												'collapsed' => 0

											];
											$columns['mailbox'] = $col;
										}
									

									// gespeicherte Spaltenanordnung
									foreach (\FOP\Database::query('SELECT * FROM fop_dataview WHERE '.qi('user').' = ' . \FOP\Database::quote(\FOP\User::getID()) . ' AND dataview = ' . \FOP\Database::quote('fop_mail_host_box_dir'))->fetchAll(\PDO::FETCH_ASSOC) AS $column => $c) {
										if (isset($columns[$c['column']])) {
											$columns[$c['column']]['order'] = $c['order']; // order, width, collapsed
											$columns[$c['column']]['width'] = $c['width']; // order, width, collapsed
											$columns[$c['column']]['collapsed'] = $c['collapsed']; // order, width, collapsed
										}
									}

									// DOM vor-rendern
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='name'
												data-order='<?php echo intval($columns['name']['order']); ?>'
												data-width='<?php echo intval($columns['name']['width']); ?>'
												data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
												style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_mail_host_box_dir_name'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_mail_host_box_dir_name'] = text.val(); } else { delete query['search_fop_mail_host_box_dir_name']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_dir').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_mail_host_box_dir_name'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_mail_host_box_dir_name'] = text2.val(); } else { delete query['searchnot_fop_mail_host_box_dir_name']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_dir').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_dir'] == 'name ASC') {
			query['sort_fop_mail_host_box_dir'] = 'name DESC';
		 } else if (query['sort_fop_mail_host_box_dir'] == 'name DESC') {
		 	delete query['sort_fop_mail_host_box_dir'];
		 } else {
			query['sort_fop_mail_host_box_dir'] = 'name ASC';
		 }
		 reloadfop_mail_host_box_dir();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('Name')); ?>'><?php echo(_('Name')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'name ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'name DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_name']) || isset($_GET['range_max_fop_mail_host_box_dir_name']) || isset($_GET['deps_fop_mail_host_box_dir_name']) || isset($_GET['fullsearch_fop_mail_host_box_dir_name']) || isset($_GET['dynamic_fop_mail_host_box_dir_name']) || isset($_GET['search_fop_mail_host_box_dir_name']) || isset($_GET['searchnot_fop_mail_host_box_dir_name']) || isset($_GET['filter_fop_mail_host_box_dir_name'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['name']['header'] = ob_get_contents(); ob_end_clean();
											$columns['name']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='name'><span class='overflow-text' title="<?php echo htmlentities($item['name']); ?>"><?php echo htmlentities($item['name']); ?></span></div><?php
											};
											$columns['name']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='name'
													data-order='<?php echo intval($columns['name']['order']); ?>'
													data-width='<?php echo intval($columns['name']['width']); ?>'
													data-collapsed='<?php echo intval($columns['name']['collapsed']); ?>'
													style='width: <?php echo intval($columns['name']['width']); ?>px; <?php if ($columns['name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if((false)){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='imap_name'
												data-order='<?php echo intval($columns['imap_name']['order']); ?>'
												data-width='<?php echo intval($columns['imap_name']['width']); ?>'
												data-collapsed='<?php echo intval($columns['imap_name']['collapsed']); ?>'
												style='width: <?php echo intval($columns['imap_name']['width']); ?>px; <?php if ($columns['imap_name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir(); 
		}});
		
		var el = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label fop-floatsorter\' style=\'width: calc(100% - 42px);\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(_('search')); ?></label></div>');
		win.append(el);
		var text = el.find('input');
		text.val(query['search_fop_mail_host_box_dir_imap_name'])
		text.on('change keyup paste', function () { if (text.val()) { query['search_fop_mail_host_box_dir_imap_name'] = text.val(); } else { delete query['search_fop_mail_host_box_dir_imap_name']; } changed = true; });
		text.focus();
		text.select();
		text.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_dir').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});

		var el2 = $('<div class=\'mdl-textfield mdl-js-textfield mdl-textfield--floating-label\'><input class=\'mdl-textfield__input\' style=\'display: inline-block;\' type=\'text\'><label class=\'mdl-textfield__input\'><?php echo(htmlentities(htmlentities(_('filter_contains_not')))); ?></label></div>');
		win.append(el2);
		var text2 = el2.find('input');
		text2.val(query['searchnot_fop_mail_host_box_dir_imap_name'])
		text2.on('change keyup paste', function () { if (text2.val()) { query['searchnot_fop_mail_host_box_dir_imap_name'] = text2.val(); } else { delete query['searchnot_fop_mail_host_box_dir_imap_name']; } changed = true; });
		text2.keydown(function (event) {if ((event.keyCode || event.which) == 13) {$('#table_fop_mail_host_box_dir').find('.fop-table-row:first').click();} if (event.key === 'Escape') { win.close(); }});
	
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_dir'] == 'imap_name ASC') {
			query['sort_fop_mail_host_box_dir'] = 'imap_name DESC';
		 } else if (query['sort_fop_mail_host_box_dir'] == 'imap_name DESC') {
		 	delete query['sort_fop_mail_host_box_dir'];
		 } else {
			query['sort_fop_mail_host_box_dir'] = 'imap_name ASC';
		 }
		 reloadfop_mail_host_box_dir();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	">
													<span class='title-title' title='<?php echo(_('IMAP-Name')); ?>'><?php echo(_('IMAP-Name')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'imap_name ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'imap_name DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_imap_name']) || isset($_GET['range_max_fop_mail_host_box_dir_imap_name']) || isset($_GET['deps_fop_mail_host_box_dir_imap_name']) || isset($_GET['fullsearch_fop_mail_host_box_dir_imap_name']) || isset($_GET['dynamic_fop_mail_host_box_dir_imap_name']) || isset($_GET['search_fop_mail_host_box_dir_imap_name']) || isset($_GET['searchnot_fop_mail_host_box_dir_imap_name']) || isset($_GET['filter_fop_mail_host_box_dir_imap_name'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['imap_name']['header'] = ob_get_contents(); ob_end_clean();
											$columns['imap_name']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['imap_name']['width']); ?>px; <?php if ($columns['imap_name']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='imap_name'><span class='overflow-text' title="<?php echo htmlentities($item['imap_name']); ?>"><?php echo htmlentities($item['imap_name']); ?></span></div><?php
											};
											$columns['imap_name']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='imap_name'
													data-order='<?php echo intval($columns['imap_name']['order']); ?>'
													data-width='<?php echo intval($columns['imap_name']['width']); ?>'
													data-collapsed='<?php echo intval($columns['imap_name']['collapsed']); ?>'
													style='width: <?php echo intval($columns['imap_name']['width']); ?>px; <?php if ($columns['imap_name']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='nmessages'
												data-order='<?php echo intval($columns['nmessages']['order']); ?>'
												data-width='<?php echo intval($columns['nmessages']['width']); ?>'
												data-collapsed='<?php echo intval($columns['nmessages']['collapsed']); ?>'
												style='width: <?php echo intval($columns['nmessages']['width']); ?>px; <?php if ($columns['nmessages']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir(); 
		}});
		var von, bis; win.append('<div class=\'fop-floatsorter\'>' + window.i18n_von + '</div>').append(von = $('<input type=\'number\' step=\'any\'><br>').val(query['range_min_fop_mail_host_box_dir_nmessages']).on('change keyup paste', function () { query['range_min_fop_mail_host_box_dir_nmessages'] = von.val(); delete query['page_fop_mail_host_box_dir']; changed = true; }))
.append('<div>' + window.i18n_bis + '</div>').append(bis = $('<input type=\'number\' step=\'any\'>').val(query['range_max_fop_mail_host_box_dir_nmessages']).on('change keyup paste', function () { query['range_max_fop_mail_host_box_dir_nmessages'] = bis.val(); delete query['page_fop_mail_host_box_dir']; changed = true; }))
; von.focus(); von.select();
	var icon, sortbtn	= $('<a class=\'mdl-button mdl-js-button mdl-button--icon mdl-button--colored\' style=\'display: inline-block;\'></a>')
		.append(icon = $('<i class=\'material-icons\'></i>').text('unfold_more'))
		.click(function() {
		 if (query['sort_fop_mail_host_box_dir'] == 'nmessages ASC') {
			query['sort_fop_mail_host_box_dir'] = 'nmessages DESC';
		 } else if (query['sort_fop_mail_host_box_dir'] == 'nmessages DESC') {
		 	delete query['sort_fop_mail_host_box_dir'];
		 } else {
			query['sort_fop_mail_host_box_dir'] = 'nmessages ASC';
		 }
		 reloadfop_mail_host_box_dir();
		 return false;
	});
	if (win.children().first().hasClass('fop-floatsorter')) {
		// floating layout
		win.prepend(sortbtn.css({float: 'right', margin: '0px'}));
	} else {
		// append to the end
		win.append(sortbtn);
	}
		return false;
	" style='text-align: right;'>
													<span class='title-title' title='<?php echo(_('news')); ?>'><?php echo(_('news')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'nmessages ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'nmessages DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_nmessages']) || isset($_GET['range_max_fop_mail_host_box_dir_nmessages']) || isset($_GET['deps_fop_mail_host_box_dir_nmessages']) || isset($_GET['fullsearch_fop_mail_host_box_dir_nmessages']) || isset($_GET['dynamic_fop_mail_host_box_dir_nmessages']) || isset($_GET['search_fop_mail_host_box_dir_nmessages']) || isset($_GET['searchnot_fop_mail_host_box_dir_nmessages']) || isset($_GET['filter_fop_mail_host_box_dir_nmessages'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['nmessages']['header'] = ob_get_contents(); ob_end_clean();
											$columns['nmessages']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['nmessages']['width']); ?>px; <?php if ($columns['nmessages']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='nmessages'><span style="white-space: nowrap; width: 100%; display: inline-block; text-align: right;"><?php echo htmlentities(\Types\Integer::print($item['nmessages'])); ?>
	</span></div><?php
											};
											$columns['nmessages']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='nmessages'
													data-order='<?php echo intval($columns['nmessages']['order']); ?>'
													data-width='<?php echo intval($columns['nmessages']['width']); ?>'
													data-collapsed='<?php echo intval($columns['nmessages']['collapsed']); ?>'
													style='width: <?php echo intval($columns['nmessages']['width']); ?>px; <?php if ($columns['nmessages']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									
										
										if(true){
											ob_start();
											?><div class="fop-table-column overlay"
												data-column='mailbox'
												data-order='<?php echo intval($columns['mailbox']['order']); ?>'
												data-width='<?php echo intval($columns['mailbox']['width']); ?>'
												data-collapsed='<?php echo intval($columns['mailbox']['collapsed']); ?>'
												style='width: <?php echo intval($columns['mailbox']['width']); ?>px; <?php if ($columns['mailbox']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
												<span class='title' onclick="
		var changed = false, win = dropDownFixPosition($(this), null, function() { if (changed) {
			
			reloadfop_mail_host_box_dir(); 
		}});
		
		win.append(getfilter_fop_mail_host_box_dir_mailboxListMultiFilter()); win.find('input').first().focus();
		return false;
	">
													<span class='title-title' title='<?php echo(_('Mailbox')); ?>'><?php echo(_('Mailbox')); ?></span>
													<?php // sort indicator
														if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'mailbox ASC') {
															?><i class='material-icons fop-small'>keyboard_arrow_down</i><?php
														} else if (isset($_GET['sort_fop_mail_host_box_dir']) && $_GET['sort_fop_mail_host_box_dir'] == 'mailbox DESC') {
															?><i class='material-icons fop-small'>keyboard_arrow_up</i><?php
														}
														if (isset($_GET['range_min_fop_mail_host_box_dir_mailbox']) || isset($_GET['range_max_fop_mail_host_box_dir_mailbox']) || isset($_GET['deps_fop_mail_host_box_dir_mailbox']) || isset($_GET['fullsearch_fop_mail_host_box_dir_mailbox']) || isset($_GET['dynamic_fop_mail_host_box_dir_mailbox']) || isset($_GET['search_fop_mail_host_box_dir_mailbox']) || isset($_GET['searchnot_fop_mail_host_box_dir_mailbox']) || isset($_GET['filter_fop_mail_host_box_dir_mailbox'])) {
															// filter indicator
															?><i class='material-icons fop-small'>filter_list</i><?php
														}
														// search indicator
														?><i class='material-icons fop-small'>search</i>
													</span>
												<div class='fop-column-handle'></div>
											</div><?php
											$columns['mailbox']['header'] = ob_get_contents(); ob_end_clean();
											$columns['mailbox']['render'] = function ($item) use (&$columns, $itemheight) {
												// Render-Callback für eine Zelle
												?><div class='fop-table-column'
													style='width: <?php echo intval($columns['mailbox']['width']); ?>px; <?php if ($columns['mailbox']['collapsed'] == 1) { echo ' display: none;'; } ?> height: <?php echo $itemheight; ?>px; ' data-column='mailbox'><?php
	
	call_user_func(function () use ($item) {
	$id = $item['mailbox'];
	$val = $item['mailbox::description'];
	$canView = $item['mailbox::canView'];
	if ($val !== null) {
		if ($canView) echo "<a tabindex=\"-1\" class=\"mdl-button mdl-button-small tbl-link\" data-tbl=\"fop_mail_host_box\" data-id=\"".htmlentities($id)."\" onclick=\"event.stopPropagation(); event.preventDefault(); open_url(this.href, false);\" href=\"" . \TablesRouter\Fop_mail_host_box::viewURL($id, ['from' => \FOP\Util::getBackURL()]) . "\">(…)</a>";echo htmlentities($val);
	} else {
		echo htmlentities(_('') ?: '-');
	}
	});
	
?>
</div><?php
											};
											$columns['mailbox']['renderSum'] = function ($item) use (&$columns) {
												// Render-Callback Summe
												?><div class='fop-table-column fop-table-column-aggregate'
													data-column='mailbox'
													data-order='<?php echo intval($columns['mailbox']['order']); ?>'
													data-width='<?php echo intval($columns['mailbox']['width']); ?>'
													data-collapsed='<?php echo intval($columns['mailbox']['collapsed']); ?>'
													style='width: <?php echo intval($columns['mailbox']['width']); ?>px; <?php if ($columns['mailbox']['collapsed'] == 1) { echo ' display: none;'; } ?>'>
													</div><?php
											};
										}
										
									

									// sort by order
									uasort($columns, function ($a, $b) {
										return $a['order'] - $b['order'];
									});
									?>
									<style type='text/css'>
										#fop_mail_host_box_dir-table .fop-table-header {
											height: <?php echo 32; ?>px;
										}
										#fop_mail_host_box_dir-table .fop-table-header .fop-table-column .title,
										#fop_mail_host_box_dir-table .fop-column-handle,
										#fop_mail_host_box_dir-table .fop-table-row,
										#fop_mail_host_box_dir-table .fop-table-row .fop-table-column,
										#fop_mail_host_box_dir-table .fop-table-column-multicontrol,
										#fop_mail_host_box_dir-table .fop-filter-button {
											height: 32px;
											line-height: 32px;
										}
										</style>
											<div class="fop-table" data-table-id="fop_mail_host_box_dir">
											<div class="fop-legend"></div>
											<div class="fop-filter-string-wrapper"><div class="fop-filter-string"><label>Filter:</label> <span><?php echo self::getFilterHTML($_GET); ?></span></div></div>
											
											<?php if (isset($_GET['select'])) { echo '<br>'; } ?>
											<div class="fop-table-header">
											<?php if (!isset($_GET['select'])) { ?>
												<div class="fop-table-column noprint" style="width: <?php echo json_encode($firstColumnWidth); ?>px;">
													
													<div class="fop-table-column-multicontrol">
													<label class="mdl-checkbox mdl-js-checkbox"  style='width: auto;' for="fop_mail_host_box_dir__all-checkbox">
														<input class="mdl-checkbox__input" id="fop_mail_host_box_dir__all-checkbox" type="checkbox" onchange="checkfop_mail_host_box_dir('all', 'ID', this.checked);">
														</label>
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_dir__mass-action" style='visibility: hidden;' onclick="$.get('DataView/Fop_mail_host_box_dir/permissions?id=' + checkfop_mail_host_box_dir(null, 'ID'), function (data) { for (var method in data) if (method != '__cnt') { var btn = $('[data-interaction-name=&quot;' + method + '&quot;]'); if (data[method] >= 1) btn.show(); else btn.hide(); btn.find('.cnt').text(data[method]); }; }); dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">more_vert</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterall" style="margin-right:auto; text-align:left;"
					onclick="for (key in query) if (key.indexOf('range_min_fop_mail_host_box_dir_') == 0 || key.indexOf('range_max_fop_mail_host_box_dir_') == 0 || key.indexOf('deps_fop_mail_host_box_dir_') == 0 || key.indexOf('fullsearch_fop_mail_host_box_dir_') == 0 || key.indexOf('dynamic_fop_mail_host_box_dir_') == 0 || key.indexOf('search_fop_mail_host_box_dir_') == 0 || key.indexOf('searchnot_fop_mail_host_box_dir_') == 0 || key.indexOf('filter_fop_mail_host_box_dir_') == 0) delete query[key]; reloadfop_mail_host_box_dir(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">list</i></span><span class="fop-menu-caption" title="<?php echo(_('view all elements')); ?>"><?php echo(_('view all elements')); ?> 
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filteronly" style="margin-right:auto; text-align:left;"
					onclick="query['filter_fop_mail_host_box_dir_ID'] = checkfop_mail_host_box_dir(null, 'ID'); delete query['page_fop_mail_host_box_dir']; reloadfop_mail_host_box_dir(); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">arrow_forward</i></span><span class="fop-menu-caption" title="<?php echo(_('view only these elements')); ?>"><?php echo(_('view only these elements')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="filterrange" style="margin-right:auto; text-align:left;"
					onclick="
		var ticks = new IDList(checkfop_mail_host_box_dir(null, 'ID'));
		var range = prompt('Bitte geben Sie den Bereich ein', '1-' + ticks.count());
		var newticks = new IDList();
		if (range) {
			range = range.split('-');
			if (range.length == 1) {
				range.push(range[0]);
			}
			var skip = (range[0] || 1) - 1;
			var take = (range[1] || Infinity) - skip;
			for (var item of ticks.all()) {
				if (skip > 0) {
					skip--;
				} else if (take > 0) {
					newticks.push(item);
					take--;
				} else break;
			}
			checkfop_mail_host_box_dir(newticks, 'ID', 'set');
		} $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">colorize</i></span><span class="fop-menu-caption" title="<?php echo(_('limit range')); ?>"><?php echo(_('limit range')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?><?php
		if(true && (!\FOP\User::getIsGuest())) { ?>
			<span class="mdl-list__item mdl-button">
				<span class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;"
					onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return;$.get('Tables/Fop_mail_host_box_dir/delete?ajax&from=<?php echo urlencode(\FOP\Util::getBackUrl()); ?>&id=' + escape(checkfop_mail_host_box_dir(null, 'ID'))).then(function () { reloadfop_mail_host_box_dir(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;">
					<span style="float:left;"><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?> (<span class='cnt'></span>)
					</span>
				</span>
			</span>
		<?php } ?>
														</ul>
														<!-- column hide -->
														<button type="button" class="mdl-button mdl-js-button mdl-button--icon" onclick="dropDownFixPosition($(this), $(this).next())">
															<i class="material-icons">visibility</i>
														</button>
														<ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu">
															<?php foreach ($columns AS $col) { ?>
																<li class="mdl-list__item mdl-button" onclick="
																	var isVisible = this.firstElementChild.innerText !== 'clear';
																	this.firstElementChild.innerText = isVisible ? 'clear' : 'visibility'; // switch icon
																	tableColumnVisibility('fop_mail_host_box_dir', <?php echo htmlentities(json_encode($col['id'])); ?>, !isVisible); // the rest is up to a helper function in layout/tables.fop
																	">
																	<i class="material-icons"><?php if ($col['collapsed']) { echo 'clear'; } else { echo 'visibility'; }?></i>
																	<?php echo htmlentities($col['desc']); ?>
																</li>
															<?php } ?>
															<li class="mdl-list__item mdl-button" onclick="
																$.get('FOP/Index/dataview?data='+encodeURIComponent(JSON.stringify({dataview: 'fop_mail_host_box_dir', reset: true}))).then(function () { location.reload(); });
																">
																<i class="material-icons">refresh</i>
																<?php echo _('reset all'); ?>
															</li>
														</ul>
													</div>
												</div><?php }
												
												foreach ($columns AS $col) {
													// Spalten-Überschrift rendern
													echo $col['header'];
												} ?>
											 </div>
											
											<div class="fop-table-body" id="table_fop_mail_host_box_dir" <?php \EasyEditor\Navigation::printScroll('dv.Fop_mail_host_box_dir', '/* scroll horiz */ this.previousElementSibling.firstElementChild.style.marginLeft = \'-\' + this.scrollLeft + \'px\';
												/* scroll verti */
												var self = this;
												if (window.DataViewScrollReloadTimeout) clearTimeout(window.DataViewScrollReloadTimeout);
												window.DataViewScrollReloadTimeout = setTimeout(function () {
													var currentPage = parseInt(query[\'page_fop_mail_host_box_dir\'] || 0);
													var paddingTop = parseInt( self.lastElementChild.style.paddingTop, 10);
													var wantedPage = Math.max(0, currentPage + Math.floor((self.scrollTop - paddingTop) / ' . ($itemheight * $itemsperpage) . '));
													if (wantedPage != currentPage) {
														query[\'page_fop_mail_host_box_dir\'] = wantedPage;
														reloadfop_mail_host_box_dir(undefined, undefined, true);
													}
												}, 50);
											'); ?>>
												<div class="fop-table-body-inner" style="min-height: <?php echo 12 + $itemheight * ($itemcount + $additionalLines); ?>px; padding-top: <?php echo $itemheight * $itemsperpage * $page; ?>px;">
												<?php foreach($arr as $itempos => $item) {
													?>
													<div class="fop-table-row" style="" data-fop_mail_host_box_dir-id="<?php echo htmlentities($item['ID']); ?>"<?php if (isset($item['ID'])){
														if (isset($_GET['select']) && isset($_GET['from'])) {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) window.location.href=' . htmlentities(json_encode($_GET['from'] . '&colvalue=' . urlencode($item['ID']))) . ';" ';
														} else {
															echo 'onclick="event.preventDefault(); if (!window.getSelection().toString()) open_url(reloadfop_mail_host_box_dir({action: \'open\', fop_table: \'fop_mail_host_box_dir\', fop_id: ' .  htmlentities(json_encode($item['ID'])) . ', fop_from: location.href}, true), false);"';
														}
													}?> >

													<?php if (!isset($_GET['select'])) { ?>
													<div class='fop-table-column noprint' style="width: <?php echo json_encode($firstColumnWidth); ?>px;" onclick="$(this).find('input[type=checkbox]').first().click(); event.stopPropagation();">
													<label onclick="event.stopPropagation();" class="mdl-checkbox mdl-js-checkbox fop_mail_host_box_dir__checkbox fop_mail_host_box_dir__checkbox fop_mail_host_box_dir__checkbox-ID-<?php echo htmlentities($item['ID']); ?>" style="width: auto;" for="fop_mail_host_box_dir__<?php echo htmlentities($itempos); ?>-checkbox">
													<input class="mdl-checkbox__input" id="fop_mail_host_box_dir__<?php echo htmlentities($itempos); ?>-checkbox" type="checkbox" onchange="<?php if (isset($item['ID'])) echo 'checkfop_mail_host_box_dir(' . htmlentities(json_encode($item['ID'])) . ', \'ID\', this.checked); ' ?>">
													</label><button type="button" class="mdl-button mdl-js-button mdl-button--icon fop_mail_host_box_dir__action" onclick="
														event.stopPropagation();
														dropDownFixPosition($(this), $(this).next());
														">
														<i class="material-icons">more_vert</i>
													</button><ul class="mdl-list mdl-card mdl-shadow--4dp fop-scroll-menu" id="fop-scroll-menu-fop_mail_host_box_dir-action-<?php echo $item['ID'] ?? 0; ?>">
														<?php
		if(isset($item['ID']) && $item['operation::view']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="view" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick=" if (!event.ctrlKey) { open_url(reloadfop_mail_host_box_dir({action: 'open', fop_table: 'fop_mail_host_box_dir', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; } $(this).closest('.overlay').click(); return false;  
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">find_in_page</i></span><span class="fop-menu-caption" title="<?php echo(_('open')); ?>"><?php echo(_('open')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="edit" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">edit</i></span><span class="fop-menu-caption" title="<?php echo(_('edit')); ?>"><?php echo(_('edit')); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && ((false)) && $item['operation::fe706a821e9bb4377035b94eb35b8e14fca50d2c8b3851f676a450526bb929a8'] && $item['operation::I7Xz8mh4']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="create_fop_mail_host_box_dir_email_directory" style="margin-right:auto; text-align:left;" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir_email::createURL2(['column_directory' => $item['ID'], 'from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="   
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">create</i></span><span class="fop-menu-caption" title="<?php echo(sprintf(_('create %s'), _('Email'))); ?>"><?php echo(sprintf(_('create %s'), _('Email'))); ?></span>
			</a>
		<?php } ?><?php
		if(isset($item['ID']) && $item['operation::delete']) { ?>
			<a class="mdl-list__item mdl-button" data-interaction-name="delete" style="margin-right:auto; text-align:left;" href="#"
				onclick="if(!confirm(<?php echo htmlentities(json_encode(_('confirmdelete'))); ?>)) return false;   $.get('Tables/Fop_mail_host_box_dir/delete?ajax&id=<?php echo htmlentities($item['ID']);?>&from=<?php echo htmlentities(\FOP\Util::getBackUrl());?>').then(function () { reloadfop_mail_host_box_dir(); }, function (err) { if (err.responseText.startsWith('http')) { window.location.href = err.responseText; } else {alert(err.responseText); }}); $(this).closest('.overlay').click(); return false;
					open_url(this.href, false);
					$(this).closest('.overlay').click();
					return false;">
				<span><i class="material-icons">delete</i></span><span class="fop-menu-caption" title="<?php echo(_('delete')); ?>"><?php echo(_('delete')); ?></span>
			</a>
		<?php } ?>
													</ul><?php
		if(isset($item['ID']) && $item['operation::view'] && $item['operation::edit']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_mail_host_box_dir" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="edit" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir::editURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();    reloadfop_mail_host_box_dir();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('edit')); ?>">
				<i class="material-icons">edit</i>
			</a><?php } ?><?php
		if(isset($item['ID']) && $item['operation::view']) {
			?><a class="mdl-button mdl-js-button mdl-button--icon tbl-link" data-tbl="fop_mail_host_box_dir" data-id="<?php echo htmlentities($item['ID']); ?>" data-interaction-name="view" href="<?php echo htmlentities(\TablesRouter\Fop_mail_host_box_dir::viewURL($item['ID'], ['from' => \FOP\Util::getBackUrl()])); ?>"
				onclick="event.stopPropagation();  if (!event.ctrlKey) { open_url(reloadfop_mail_host_box_dir({action: 'open', fop_table: 'fop_mail_host_box_dir', fop_id: <?php echo htmlentities(json_encode($item['ID'])); ?>, fop_from: location.href}, true), false); return false; }  reloadfop_mail_host_box_dir();
					$(this).closest('.overlay').click();
					if (this.href != '#') {
						open_url(this.href, false);
					}
					event.preventDefault();"
				title="<?php echo(_('open')); ?>">
				<i class="material-icons">find_in_page</i>
			</a><?php } ?>
													</div><?php } ?><?php
													
													foreach ($columns AS $col) {
														$col['render']($item);
													}
													?></div>
												 <?php }?>

													</div>
												</div>

												
												
												</div><?php
												
	
    
  }

  public static function getidsAction($col) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
			$q = \FOP\Database::query('SELECT t.'.qi($col).' '.self::getSQL($_GET));
			$result = new \FOP\IDList();
			while ($item = $q->fetchColumn()) {
				$result->push($item);
			}
			die($result->toString());

    
  }

  public static function permissionsAction($id) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		$ids = new \FOP\IDList($id);
		header('Content-Type: application/json');
		
		$perms = \FOP\Database::query('SELECT COUNT(*) AS __cnt, SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filteronly').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterrange').', SUM(CASE (TRUE) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('filterall').', SUM(CASE (((('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'INBOX\')) AND (('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'Sent\')))) WHEN TRUE THEN 1 ELSE 0 END) AS '.qi('delete').' FROM '.qi('fop_mail_host_box_dir').' WHERE ' . $ids->toSQL(qi('ID')))->fetch(\PDO::FETCH_ASSOC);
		
		return $perms;
	
    
  }

  public static function getSQL($params) { 
    
    
    // --- BLOCK: dependency-fop_mail_host_box_dir ---
    
		if (isset($params['select']) && $params['select'] == 'fop_mail_host_box_dir') {
			$deps = [];
		}
	
    // --- BLOCK: dependency-fop_mail_host_box_dirMailbox ---
    
		if (isset($params['select']) && $params['select'] == 'fop_mail_host_box_dirMailbox') {
			$deps = ['mbox' => $params['deps_fop_mail_host_box_dir_mbox']];
		}
	
    // --- BLOCK: dependency-fop_mail_host_box_dirParent ---
    
		if (isset($params['select']) && $params['select'] == 'fop_mail_host_box_dirParent') {
			$deps = ['mbox_parent' => $params['deps_fop_mail_host_box_dir_mbox_parent']];
		}
	
    // --- BLOCK: main ---
    
								// returns a sql snippet 'FROM (...) AS t WHERE' where you can prepend your select clauses and append your ORDER LIMIT
								$sql = 'FROM (SELECT /* ID */ '.qi('ID').' AS '.qi('ID').',
									/* attributes */ '.qi('attributes').' AS '.qi('attributes').',
									/* delimiter */ '.qi('delimiter').' AS '.qi('delimiter').',
									/* imap_name */ '.qi('imap_name').' AS '.qi('imap_name').',
									/* mailbox */ '.qi('mailbox').' AS '.qi('mailbox').',
									/* mailbox::canView */ '.qi('ref:mailbox').'.'.qi('mailbox:canView').' AS '.qi('mailbox::canView').',
									/* mailbox::description */ '.qi('ref:mailbox').'.'.qi('mailbox:description').' AS '.qi('mailbox::description').',
									/* name */ '.qi('name').' AS '.qi('name').',
									/* nmessages */ (SELECT COUNT(1) FROM '.qi('fop_mail_host_box_dir_email').' '.qi('jUoCMu9k').' WHERE '.qi('jUoCMu9k').'.'.qi('directory').' = '.qi('fop_mail_host_box_dir').'.'.qi('ID').' LIMIT 1) AS '.qi('nmessages').',
									/* operation::I7Xz8mh4 */ (COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir').'.'.qi('mailbox').' LIMIT 1), FALSE)) AS '.qi('operation::I7Xz8mh4').',
									/* operation::create */ ((('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'INBOX\')) AND (('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'Sent\'))) AS '.qi('operation::create').',
									/* operation::delete */ ((('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'INBOX\')) AND (('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'Sent\'))) AS '.qi('operation::delete').',
									/* operation::edit */ ((('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'INBOX\')) AND (('.qi('fop_mail_host_box_dir').'.'.qi('name').') <> (\'Sent\'))) AS '.qi('operation::edit').',
									/* operation::f219cf8d42b3c4dbc0e31067a054c8622e34128a02925c52c9bc31f9558d4c35 */ COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir').'.'.qi('mailbox').' LIMIT 1), FALSE) AS '.qi('operation::f219cf8d42b3c4dbc0e31067a054c8622e34128a02925c52c9bc31f9558d4c35').',
									/* operation::fe706a821e9bb4377035b94eb35b8e14fca50d2c8b3851f676a450526bb929a8 */ COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir').'.'.qi('mailbox').' LIMIT 1), FALSE) AS '.qi('operation::fe706a821e9bb4377035b94eb35b8e14fca50d2c8b3851f676a450526bb929a8').',
									/* operation::index */ ' . (!\FOP\User::getIsGuest() ? 1 : 0) . ' AS '.qi('operation::index').',
									/* operation::view */ (COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir').'.'.qi('mailbox').' LIMIT 1), FALSE)) AS '.qi('operation::view').',
									1
								FROM '.qi('fop_mail_host_box_dir').' '.qi('fop_mail_host_box_dir').'
								LEFT JOIN (SELECT '.qi('ID').' AS '.qi('mailbox:ID').', '.qi('fop_mail_host_box').'.'.qi('from_address').' AS '.qi('mailbox:description').', ((CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('fop_mail_host_box').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END)) AS '.qi('mailbox:canView').' FROM '.qi('fop_mail_host_box').') '.qi('ref:mailbox').' ON '.qi('ref:mailbox').'.'.qi('mailbox:ID').' = '.qi('mailbox').'
								WHERE (((COALESCE((SELECT (CASE WHEN FALSE THEN TRUE ELSE NOT (('.qi('1IDxgk3w').'.'.qi('fopuser').') <> ('.\FOP\Database::sessionVarSQL('user').')) END) FROM '.qi('fop_mail_host_box').' '.qi('1IDxgk3w').' WHERE '.qi('1IDxgk3w').'.'.qi('ID').' = '.qi('fop_mail_host_box_dir').'.'.qi('mailbox').' LIMIT 1), FALSE))))
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'fop_mail_host_box_dir' ? 'TRUE' : 'TRUE') . ')
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'fop_mail_host_box_dirMailbox' ? '(('.qi('fop_mail_host_box_dir').'.'.qi('mailbox').') = (' . \FOP\Database::quote($deps['mbox']) . '))' : 'TRUE') . ')
									AND (' . (isset($_GET['select']) && $_GET['select'] == 'fop_mail_host_box_dirParent' ? '(('.qi('fop_mail_host_box_dir').'.'.qi('mailbox').') = (' . \FOP\Database::quote($deps['mbox_parent']) . '))' : 'TRUE') . ')) AS t
								WHERE ' . (isset($params['range_min_fop_mail_host_box_dir_nmessages']) ? ($params['range_min_fop_mail_host_box_dir_nmessages'] !== '' && is_numeric($params['range_min_fop_mail_host_box_dir_nmessages']) ? 't.'.qi('nmessages').' >= ' . \FOP\Database::quote($params['range_min_fop_mail_host_box_dir_nmessages']) . ' AND ' : '') : '') . 
								(isset($params['range_max_fop_mail_host_box_dir_nmessages']) ? ($params['range_max_fop_mail_host_box_dir_nmessages'] !== '' && is_numeric($params['range_max_fop_mail_host_box_dir_nmessages']) ? 't.'.qi('nmessages').' <= ' . \FOP\Database::quote($params['range_max_fop_mail_host_box_dir_nmessages']) . ' AND ' : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_name']) ? ($params['filter_fop_mail_host_box_dir_name'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_name']))->toSQL('t.'.qi('name').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_imap_name']) ? ($params['filter_fop_mail_host_box_dir_imap_name'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_imap_name']))->toSQL('t.'.qi('imap_name').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_nmessages']) ? ($params['filter_fop_mail_host_box_dir_nmessages'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_nmessages']))->toSQL('t.'.qi('nmessages').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_mailbox']) ? ($params['filter_fop_mail_host_box_dir_mailbox'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_mailbox']))->toSQL('t.'.qi('mailbox').'') . ') AND ') : '') : '') . 
								(isset($params['filter_fop_mail_host_box_dir_ID']) ? ($params['filter_fop_mail_host_box_dir_ID'] !== '' ? ('(' . (new \FOP\IDList($params['filter_fop_mail_host_box_dir_ID']))->toSQL('t.'.qi('ID').'') . ') AND ') : '') : '') . 
								(isset($params['search_fop_mail_host_box_dir_name']) ? 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_dir_name'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_mail_host_box_dir_imap_name']) ? 't.'.qi('imap_name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_dir_imap_name'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_mail_host_box_dir_name']) ? 'NOT t.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_mail_host_box_dir_name'] . '%') . ' AND ' : '') . 
								(isset($params['searchnot_fop_mail_host_box_dir_imap_name']) ? 'NOT t.'.qi('imap_name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['searchnot_fop_mail_host_box_dir_imap_name'] . '%') . ' AND ' : '') . 
								(isset($params['search_fop_mail_host_box_dir']) ? '(' . 't.'.qi('name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_dir'] . '%') . ' OR ' . 't.'.qi('imap_name').' '.(\FOP\Database::getDriver() == 'pgsql' ? 'ILIKE' : 'LIKE').' ' . \FOP\Database::quote('%' . $params['search_fop_mail_host_box_dir'] . '%') . ') AND ' : '') . 
								'
								 TRUE ';
								return $sql;
	
    
  }

  public static function getfilter_fop_mail_host_box_dir_mailboxItemsByStringAction($fstr) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
		// Auf aktive DataView-Items einschränken
		$params = $_GET;
		unset($params['filter_fop_mail_host_box_dir_mailbox']);
		return \Types\Fop_mail_host_box::getItems(null, -1, $fstr, ''.qi('ID').' IN (SELECT DISTINCT t.'.qi('mailbox').''.self::getSQL($params).')');
	

    
  }

  public static function getData($sqladdon, $params, $stream = false ) { 
    
    
    // --- BLOCK: main ---
    
								$sql = self::getSQL($params);

								$order = (\FOP\Util::array_value(array(
									'name ASC' => 'ORDER BY t.'.qi('name').' ASC',
									'imap_name ASC' => 'ORDER BY t.'.qi('imap_name').' ASC',
									'nmessages ASC' => 'ORDER BY t.'.qi('nmessages').' ASC',
									'name DESC' => 'ORDER BY t.'.qi('name').' DESC',
									'imap_name DESC' => 'ORDER BY t.'.qi('imap_name').' DESC',
									'nmessages DESC' => 'ORDER BY t.'.qi('nmessages').' DESC',
									'' => ''), isset($params['sort_fop_mail_host_box_dir']) ? $params['sort_fop_mail_host_box_dir'] : '') ?: '');
								// wenn sqladdon bereits ein ORDER enthält, kein order aufbauen
								if (strpos($sqladdon, 'ORDER') !== false) {
									$order = '';
								}
								if ($stream) {
									// als Stream (währenddessen darf keine weitere SQL-Query laufen) für große Datenmengen und Statistiken
									$result = (function () use ($sql, $order, $sqladdon) {
										$stream = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
										while ($item = $stream->fetch(\PDO::FETCH_ASSOC)) {
											$item['nmessages'] = \Types\Integer::unpack($item['nmessages']);
											$item['mailbox'] = \FOP\Sanitizers::null_converter($item['mailbox']);
											
											yield $item;
										}
									})();
								} else {
									// als RAM-Array
									$result = \FOP\Database::query('SELECT t.* ' . $sql . $order . $sqladdon);
									$arr = $result->fetchAll(\PDO::FETCH_ASSOC);
									$itemcount = count($arr);

									foreach($arr as $i => &$item){
										$item['nmessages'] = \Types\Integer::unpack($item['nmessages']);
										$item['mailbox'] = \FOP\Sanitizers::null_converter($item['mailbox']);
										
									}
									unset($item);

									$result = ["items" => $arr, "itemcount" => $itemcount];

									
								}

								return $result;
	
    
  }

  public static function getFilterHTML($params, $delimiter = ', ' , $showButton = true ) { 
    
    
    // --- BLOCK: main ---
    
		// Contract: ist showButton == false, sollten keine HTML-Tags im Output enthalten sein (Verwendung in Dateinamen!!)
		$filters = [];
		
	if (isset($params['range_min_fop_mail_host_box_dir_nmessages']) && isset($params['range_max_fop_mail_host_box_dir_nmessages'])) {
		array_push($filters, _('news') . ': ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_nmessages'])
	) . ' ' . _('filters_between') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_nmessages'])
	));
	} else if (isset($params['range_min_fop_mail_host_box_dir_nmessages'])) {
		array_push($filters, _('news') . ': ' . _('filters_from') . ' ' . (\Types\Integer::print($params['range_min_fop_mail_host_box_dir_nmessages'])
	));
	} else if (isset($params['range_max_fop_mail_host_box_dir_nmessages'])) {
		array_push($filters, _('news') . ': ' . _('filters_to') . ' ' . (\Types\Integer::print($params['range_max_fop_mail_host_box_dir_nmessages'])
	));
	}if (isset($params['filter_fop_mail_host_box_dir_name'])) {
		if ($params['filter_fop_mail_host_box_dir_name'] == '_null') {
			array_push($filters, _('Name') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_name']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Name') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_imap_name'])) {
		if ($params['filter_fop_mail_host_box_dir_imap_name'] == '_null') {
			array_push($filters, _('IMAP-Name') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_imap_name']))->all() AS $val) {
				$value = $val;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('IMAP-Name') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_nmessages'])) {
		if ($params['filter_fop_mail_host_box_dir_nmessages'] == '_null') {
			array_push($filters, _('news') . ': ' . 'NULL');
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_nmessages']))->all() AS $val) {
				$value = \Types\Integer::print($val)
	;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('news') . ': ' . implode(', ', $values));
		}
	}if (isset($params['filter_fop_mail_host_box_dir_mailbox'])) {
		if ($params['filter_fop_mail_host_box_dir_mailbox'] == '_null') {
			array_push($filters, _('Mailbox') . ': ' . _(''));
		} else {
			$values = [];
			foreach ((new \FOP\IDList($params['filter_fop_mail_host_box_dir_mailbox']))->all() AS $val) {
				$value = 
  \FOP\Database::query('SELECT '.qi('fop_mail_host_box').'.'.qi('from_address').' AS description FROM '.qi('fop_mail_host_box').' WHERE '.qi('ID').' = ' . \FOP\Database::quote($val))->fetchColumn() ?: _('')
;
				if ($value) array_push($values, $value);
			}
			array_push($filters, _('Mailbox') . ': ' . implode(', ', $values));
		}
	}if (isset($params['search_fop_mail_host_box_dir_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains') . ' ' . $params['search_fop_mail_host_box_dir_name']);
	}if (isset($params['search_fop_mail_host_box_dir_imap_name'])) {
		array_push($filters, _('imap_name') . ' ' . _('filter_contains') . ' ' . $params['search_fop_mail_host_box_dir_imap_name']);
	}if (isset($params['searchnot_fop_mail_host_box_dir_name'])) {
		array_push($filters, _('name') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_mail_host_box_dir_name']);
	}if (isset($params['searchnot_fop_mail_host_box_dir_imap_name'])) {
		array_push($filters, _('imap_name') . ' ' . _('filter_contains_not') . ' ' . $params['searchnot_fop_mail_host_box_dir_imap_name']);
	}
		if (count($filters)) {
			$result = implode($delimiter, array_map(function ($filter) {
				if (is_array($filter)) {
					return implode('', $filter);
				}
				return htmlentities($filter);
			}, $filters))
			// Button, um Filter zu entfernen
			. ($showButton ? '<i class="material-icons fop-small" style="cursor: pointer;" onclick="for (var q in query) {if (q.includes(\'_fop_mail_host_box_dir_\')) delete query[q];} reloadfop_mail_host_box_dir(); ">clear</i>' : '');
		} else {
			$result = _('no_filter');
		}
		return $result;
	
    
  }

  public static function openAction($fop_table, $fop_id, $fop_from) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    

if ($fop_table == 'fop_mail_host_box_dir') {
	\FOP\Session::setPayload('dv-fop_mail_host_box_dir', [
		'id' => 'fop_mail_host_box_dir',
		'tbl' => 'fop_mail_host_box_dir',
		'idcol' => 'ID',
		'prev' => \DataViewRouter\Fop_mail_host_box_dir::stepURL('fop_mail_host_box_dir', 'XXX', -1),
		'next' => \DataViewRouter\Fop_mail_host_box_dir::stepURL('fop_mail_host_box_dir', 'XXX',  1),
		'from' => $fop_from
	]);
	
	if ($fop_id == '_') return; // nur Rückreferenz setzen, nicht öffnen
	$params = [];
	if (isset($_GET['popup'])) $params['popup'] = true;
	if (isset($_GET['from'])) $params['from'] = $_GET['from'];
	$params['id'] = $fop_id;
	
	$url = \TablesRouter\Fop_mail_host_box_dir::viewURL2($params);
	header('Location: ' . $url);
}

die();
    
  }

  public static function stepAction($tbl, $id, $step) { 
    
    
    // --- BLOCK: access ---
    
    // --- BLOCK: main ---
    
	$dv = \FOP\Session::getPayload('dv-'.$tbl);
	$url = $dv['from'];
	$parts = parse_url($url);
	parse_str($parts['query'], $query);
	$data = self::getData('', $query);
	$col = $dv['idcol'];
	$ids = array_map(function ($x) use ($col) {return $x[$col];}, $data['items']);
	if (!count($ids)) {
		header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])));
		die();
	}
	$idx = array_search($id, $ids);
	$idx += count($ids) + $step;
	$idx = $idx % count($ids);
	header('Location: ' . \FOP\Util::getCurrentBaseurl() . 'Tables/' . preg_replace('/[^a-zA-Z0-9_]/', '_', ucfirst($dv['tbl'])) . '/view?id=' . urlencode($ids[$idx]));
	die();

    
  }


  
  

  
  
}



